package com.provider1;

import com.wrox.Appointment;

import java.io.StringReader;

//JDOM packages required for XML parsing and XML Document creation
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;

public class Provider1Appointment implements Appointment {

  /** Creates new Provider1Appointment */
  public Provider1Appointment() {
  }

  public String getProviderDetails() {

    Element ProviderDetailsRoot = new Element("PROVIDER-DETAILS");
    ProviderDetailsRoot.setAttribute("PROVIDERID","1");
    ProviderDetailsRoot.addContent(new Element("NAME").setText("PROVIDER 1"));
    ProviderDetailsRoot.addContent(new Element("ADDR1").setText("123 Street"));
    ProviderDetailsRoot.addContent(new Element("ADDR2").setText("Suite 100"));
    ProviderDetailsRoot.addContent(new Element("CITY").setText("San Jose"));
    ProviderDetailsRoot.addContent(new Element("STATE").setText("CA"));
    ProviderDetailsRoot.addContent(new Element("ZIPCODE").setText("95000"));
    ProviderDetailsRoot.addContent(new Element("PHONE").setText("408-123-4567"));
    ProviderDetailsRoot.addContent(new Element("FAX").setText("408-456-7890"));
    ProviderDetailsRoot.addContent(new Element("EMAIL").setText("info@provider1.com"));
    Document ProviderDetails = new Document(ProviderDetailsRoot);
    XMLOutputter outputter = new XMLOutputter("  ",true);
    return outputter.outputString(ProviderDetails);
  }

  public String getAppointmentSlots(String inputReq) {
    Element AppointmentsRoot = new Element("PROVIDER-APPOINTMENTS");
    AppointmentsRoot.setAttribute("PROVIDERID","1");
  
    //Appointment 1
    Element Appointment1 = new Element("APPOINTMENT");
    Appointment1.setAttribute("ID","A-1000");
    Appointment1.addContent(new Element("DATE").setText("1 NOV 2001"));
    Appointment1.addContent(new Element("TIME").setText("11:00 AM"));

    //Appointment 2
    Element Appointment2 = new Element("APPOINTMENT");
    Appointment2.setAttribute("ID","A-1001");
    Appointment2.addContent(new Element("DATE").setText("1 NOV 2001"));
    Appointment2.addContent(new Element("TIME").setText("2:00 PM"));
  
    //Appointment 3
    Element Appointment3 = new Element("APPOINTMENT");
    Appointment3.setAttribute("ID","A-1002");
    Appointment3.addContent(new Element("DATE").setText("3 NOV 2001"));
    Appointment3.addContent(new Element("TIME").setText("8:00 AM"));
  
    AppointmentsRoot.addContent(Appointment1);
    AppointmentsRoot.addContent(Appointment2);
    AppointmentsRoot.addContent(Appointment3);

    Document AppointmentSlots = new Document(AppointmentsRoot);
    XMLOutputter outputter = new XMLOutputter("  ",true);
    return outputter.outputString(AppointmentSlots);
  }

  public String reserveAppointment(String inputReq) {
    System.out.println("Received Appointment");
    System.out.println("--------------------");
       
    //Parse the Appointment Request
    try {
      SAXBuilder builder = new SAXBuilder();
      Document AppointmentReq = builder.build(new StringReader(inputReq));
      Element AppointmentReqRoot = AppointmentReq.getRootElement();
      String providerId = AppointmentReqRoot.getAttribute ("PROVIDERID").getValue();
      String patientId  = AppointmentReqRoot.getChild("PATIENTID").getText();
      String apptId     = AppointmentReqRoot.getChild("APPOINTMENT-ID").getText();
      
      //Prepare Response
      Element AppointmentRespRoot = new Element("PROVIDER-APPOINTMENTRESPONSE");
      AppointmentRespRoot.setAttribute("PROVIDERID","1");
      AppointmentRespRoot.addContent(new Element("PATIENTID").setText(patientId));
      AppointmentRespRoot.addContent(new Element("APPOINTMENT-ID").setText(apptId));
      AppointmentRespRoot.addContent(new Element("STATUS").setText("OK"));
      Document AppointmentResponse = new Document(AppointmentRespRoot);
      XMLOutputter outputter = new XMLOutputter("  ",true);
      return outputter.outputString(AppointmentResponse);

    } catch (Exception e) {
      System.out.println("ERROR");
      return "ERROR";
    }
  }
}