package com.wrox;

import com_interface.provider1appointmentservice.www.*;

import java.io.StringReader;

import java.util.Iterator;
import java.util.Hashtable;
import java.util.ArrayList;
import java.util.List;

import java.net.URL;

//JDOM packages
import  org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;
import org.jdom.Document;
import org.jdom.Element;

public class ProviderProxy {

   Hashtable providerUrl;  //Stores the providerURLs hashed by providerId
   ArrayList providerList; // The list of current providers

  public ProviderProxy() {
    providerUrl = new Hashtable(2);
    providerUrl.put("Provider 1", "http://localhost:7080/soap/servlet/rpcrouter");
    providerUrl.put("Provider 2", "http://localhost:9080/soap/servlet/rpcrouter");

    providerList = new ArrayList(2);
    providerList.add("Provider 1");
    providerList.add("Provider 2");
  }

  public ArrayList getProviders() throws Exception {
    return providerList;
  }

  public String getProviderURL(String providerId) throws Exception {
    return (String) providerUrl.get(providerId);
  }

  public ProviderDetail getProviderDetails(String providerId)
     throws Exception {
    Provider1Appointment_ServiceBinding service = new Provider1Appointment_ServiceBinding(new URL(getProviderURL(providerId)));

    String providerDetails = service.getProviderDetails();
    //Parse the ProviderDetail Information
    try {
      SAXBuilder builder = new SAXBuilder();
      Document provDetailDoc = builder.build(new StringReader(providerDetails));
      Element provDetailRoot = provDetailDoc.getRootElement();
      String providerName = provDetailRoot.getChild("NAME").getText();
      String addr1 = provDetailRoot.getChild("ADDR1").getText();
      String addr2 = provDetailRoot.getChild("ADDR2").getText();
      String city  = provDetailRoot.getChild("CITY").getText();
      String state = provDetailRoot.getChild("STATE").getText();
      String zipcode = provDetailRoot.getChild("ZIPCODE").getText();
      String phone = provDetailRoot.getChild("PHONE").getText();
      String fax = provDetailRoot.getChild("FAX").getText();
      String email = provDetailRoot.getChild("EMAIL").getText();
      
      ProviderDetail providerDetail = new ProviderDetail();
      providerDetail.setProviderId(providerId);
      providerDetail.setProviderName(providerName);
      providerDetail.setAddr1(addr1);
      providerDetail.setAddr2(addr2);
      providerDetail.setCity(city);
      providerDetail.setState(state);
      providerDetail.setZipcode(zipcode);
      providerDetail.setPhone(phone);
      providerDetail.setFax(fax);
      providerDetail.setEmail(email);

      return providerDetail;

    } catch (Exception e) {
      throw e;
    }
  }
  
  public ArrayList getAvailableAppointments(String providerId) 
     throws Exception {

    ArrayList AvailableAppointmentsList = new ArrayList();
    Provider1Appointment_ServiceBinding service = new Provider1Appointment_ServiceBinding( new URL(getProviderURL(providerId)));
    String ApptList = service.getAppointmentSlots("");
    
        //Parse the Appointment Detail Information
    try {
      SAXBuilder builder = new SAXBuilder ();
      Document ApptListDoc  = builder.build(new StringReader(ApptList));
      Element  ApptListRoot = ApptListDoc.getRootElement();

      List list = ApptListRoot.getChildren("APPOINTMENT");
      Iterator iterator = list.iterator();

      while (iterator.hasNext()) {
        Element Appointment = (Element)iterator.next();
        String ApptId = Appointment.getAttribute("ID").getValue();
        String ApptDate = Appointment.getChild("DATE").getText();
        String ApptTime = Appointment.getChild("TIME").getText();

        AppointmentDetail ApptDetail = new AppointmentDetail();
        ApptDetail.setAppointmentId(ApptId);
        ApptDetail.setAppointmentDate(ApptDate);
        ApptDetail.setAppointmentTime(ApptTime);

        AvailableAppointmentsList.add(ApptDetail);
      }
      return AvailableAppointmentsList;

    } catch (Exception e) {
      throw e;
    }
  }

  public String makeReservation(String clientId, String providerId, String ApptId) throws Exception {

    //Make the XML Request
    Element rootElement = new Element("PROVIDER-APPOINTMENTREQUEST");
    rootElement.setAttribute("PROVIDERID",providerId);
    rootElement.addContent(new Element("PATIENTID").setText(clientId));
    rootElement.addContent(new Element("APPOINTMENT-ID").setText(ApptId));
    Document AppointmentDetails = new Document(rootElement);
    XMLOutputter outputter = new XMLOutputter("  ",true);
    String AppointmentRequest = outputter.outputString(AppointmentDetails);

    Provider1Appointment_ServiceBinding service = new Provider1Appointment_ServiceBinding( new URL(getProviderURL(providerId)));
    String result = service.reserveAppointment(AppointmentRequest);

    //Parse the MakeReservation Result
    try {
      SAXBuilder builder = new SAXBuilder();
      Document ReservationResult = builder.build(new StringReader(result));
      Element  ReservationResultRoot = ReservationResult.getRootElement();
      String   status = ReservationResultRoot.getChild("STATUS").getText();

      return status;

    } catch (Exception e) {
      throw e;
    }
  }
}